<?php

namespace Ulmus\Query;

class GroupBy extends Fragment {
    public int $order = 70;

    public array $groupBy = [];

    public function set(array $order) : self
    {
        $this->groupBy = $order;
        return $this;
    }

    public function add(string $field, ? string $direction = null) : self
    {
        $this->groupBy[] = $field;
        return $this;
    }

    public function render() : string
    {
        return $this->renderSegments([
            'GROUP BY', implode(", ", $this->groupBy)
        ]);
    }

}
